// This file was generated by counterfeiter
package fakes

import (
	"sync"

	"github.com/cloudfoundry-incubator/garden-shed/docker_drivers/aufs"
)

type FakeLoopMounter struct {
	MountFileStub        func(filePath, destPath string) error
	mountFileMutex       sync.RWMutex
	mountFileArgsForCall []struct {
		filePath string
		destPath string
	}
	mountFileReturns struct {
		result1 error
	}
	UnmountStub        func(path string) error
	unmountMutex       sync.RWMutex
	unmountArgsForCall []struct {
		path string
	}
	unmountReturns struct {
		result1 error
	}
}

func (fake *FakeLoopMounter) MountFile(filePath string, destPath string) error {
	fake.mountFileMutex.Lock()
	fake.mountFileArgsForCall = append(fake.mountFileArgsForCall, struct {
		filePath string
		destPath string
	}{filePath, destPath})
	fake.mountFileMutex.Unlock()
	if fake.MountFileStub != nil {
		return fake.MountFileStub(filePath, destPath)
	} else {
		return fake.mountFileReturns.result1
	}
}

func (fake *FakeLoopMounter) MountFileCallCount() int {
	fake.mountFileMutex.RLock()
	defer fake.mountFileMutex.RUnlock()
	return len(fake.mountFileArgsForCall)
}

func (fake *FakeLoopMounter) MountFileArgsForCall(i int) (string, string) {
	fake.mountFileMutex.RLock()
	defer fake.mountFileMutex.RUnlock()
	return fake.mountFileArgsForCall[i].filePath, fake.mountFileArgsForCall[i].destPath
}

func (fake *FakeLoopMounter) MountFileReturns(result1 error) {
	fake.MountFileStub = nil
	fake.mountFileReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeLoopMounter) Unmount(path string) error {
	fake.unmountMutex.Lock()
	fake.unmountArgsForCall = append(fake.unmountArgsForCall, struct {
		path string
	}{path})
	fake.unmountMutex.Unlock()
	if fake.UnmountStub != nil {
		return fake.UnmountStub(path)
	} else {
		return fake.unmountReturns.result1
	}
}

func (fake *FakeLoopMounter) UnmountCallCount() int {
	fake.unmountMutex.RLock()
	defer fake.unmountMutex.RUnlock()
	return len(fake.unmountArgsForCall)
}

func (fake *FakeLoopMounter) UnmountArgsForCall(i int) string {
	fake.unmountMutex.RLock()
	defer fake.unmountMutex.RUnlock()
	return fake.unmountArgsForCall[i].path
}

func (fake *FakeLoopMounter) UnmountReturns(result1 error) {
	fake.UnmountStub = nil
	fake.unmountReturns = struct {
		result1 error
	}{result1}
}

var _ aufs.LoopMounter = new(FakeLoopMounter)
