// This file was generated by counterfeiter
package fakes

import (
	"sync"

	"github.com/cloudfoundry-incubator/guardian/kawasaki/dns"
	"github.com/pivotal-golang/lager"
)

type FakeCompiler struct {
	CompileStub        func(log lager.Logger) ([]byte, error)
	compileMutex       sync.RWMutex
	compileArgsForCall []struct {
		log lager.Logger
	}
	compileReturns struct {
		result1 []byte
		result2 error
	}
}

func (fake *FakeCompiler) Compile(log lager.Logger) ([]byte, error) {
	fake.compileMutex.Lock()
	fake.compileArgsForCall = append(fake.compileArgsForCall, struct {
		log lager.Logger
	}{log})
	fake.compileMutex.Unlock()
	if fake.CompileStub != nil {
		return fake.CompileStub(log)
	} else {
		return fake.compileReturns.result1, fake.compileReturns.result2
	}
}

func (fake *FakeCompiler) CompileCallCount() int {
	fake.compileMutex.RLock()
	defer fake.compileMutex.RUnlock()
	return len(fake.compileArgsForCall)
}

func (fake *FakeCompiler) CompileArgsForCall(i int) lager.Logger {
	fake.compileMutex.RLock()
	defer fake.compileMutex.RUnlock()
	return fake.compileArgsForCall[i].log
}

func (fake *FakeCompiler) CompileReturns(result1 []byte, result2 error) {
	fake.CompileStub = nil
	fake.compileReturns = struct {
		result1 []byte
		result2 error
	}{result1, result2}
}

var _ dns.Compiler = new(FakeCompiler)
