// This file was generated by counterfeiter
package fakes

import (
	"sync"

	"github.com/cloudfoundry-incubator/garden"
	"github.com/cloudfoundry-incubator/guardian/kawasaki"
	"github.com/pivotal-golang/lager"
)

type FakeFirewallOpener struct {
	OpenStub        func(log lager.Logger, instance string, rule garden.NetOutRule) error
	openMutex       sync.RWMutex
	openArgsForCall []struct {
		log      lager.Logger
		instance string
		rule     garden.NetOutRule
	}
	openReturns struct {
		result1 error
	}
}

func (fake *FakeFirewallOpener) Open(log lager.Logger, instance string, rule garden.NetOutRule) error {
	fake.openMutex.Lock()
	fake.openArgsForCall = append(fake.openArgsForCall, struct {
		log      lager.Logger
		instance string
		rule     garden.NetOutRule
	}{log, instance, rule})
	fake.openMutex.Unlock()
	if fake.OpenStub != nil {
		return fake.OpenStub(log, instance, rule)
	} else {
		return fake.openReturns.result1
	}
}

func (fake *FakeFirewallOpener) OpenCallCount() int {
	fake.openMutex.RLock()
	defer fake.openMutex.RUnlock()
	return len(fake.openArgsForCall)
}

func (fake *FakeFirewallOpener) OpenArgsForCall(i int) (lager.Logger, string, garden.NetOutRule) {
	fake.openMutex.RLock()
	defer fake.openMutex.RUnlock()
	return fake.openArgsForCall[i].log, fake.openArgsForCall[i].instance, fake.openArgsForCall[i].rule
}

func (fake *FakeFirewallOpener) OpenReturns(result1 error) {
	fake.OpenStub = nil
	fake.openReturns = struct {
		result1 error
	}{result1}
}

var _ kawasaki.FirewallOpener = new(FakeFirewallOpener)
