// This file was generated by counterfeiter
package fakes

import (
	"sync"

	"github.com/cloudfoundry-incubator/garden"
	"github.com/cloudfoundry-incubator/guardian/gardener"
	"github.com/cloudfoundry-incubator/guardian/kawasaki"
	"github.com/pivotal-golang/lager"
)

type FakeNetworkHooker struct {
	HooksStub        func(log lager.Logger, containerSpec garden.ContainerSpec) (gardener.Hooks, error)
	hooksMutex       sync.RWMutex
	hooksArgsForCall []struct {
		log           lager.Logger
		containerSpec garden.ContainerSpec
	}
	hooksReturns struct {
		result1 gardener.Hooks
		result2 error
	}
}

func (fake *FakeNetworkHooker) Hooks(log lager.Logger, containerSpec garden.ContainerSpec) (gardener.Hooks, error) {
	fake.hooksMutex.Lock()
	fake.hooksArgsForCall = append(fake.hooksArgsForCall, struct {
		log           lager.Logger
		containerSpec garden.ContainerSpec
	}{log, containerSpec})
	fake.hooksMutex.Unlock()
	if fake.HooksStub != nil {
		return fake.HooksStub(log, containerSpec)
	} else {
		return fake.hooksReturns.result1, fake.hooksReturns.result2
	}
}

func (fake *FakeNetworkHooker) HooksCallCount() int {
	fake.hooksMutex.RLock()
	defer fake.hooksMutex.RUnlock()
	return len(fake.hooksArgsForCall)
}

func (fake *FakeNetworkHooker) HooksArgsForCall(i int) (lager.Logger, garden.ContainerSpec) {
	fake.hooksMutex.RLock()
	defer fake.hooksMutex.RUnlock()
	return fake.hooksArgsForCall[i].log, fake.hooksArgsForCall[i].containerSpec
}

func (fake *FakeNetworkHooker) HooksReturns(result1 gardener.Hooks, result2 error) {
	fake.HooksStub = nil
	fake.hooksReturns = struct {
		result1 gardener.Hooks
		result2 error
	}{result1, result2}
}

var _ kawasaki.NetworkHooker = new(FakeNetworkHooker)
