// This file was generated by counterfeiter
package fakes

import (
	"sync"

	"github.com/cloudfoundry-incubator/guardian/kawasaki"
)

type FakePortPool struct {
	AcquireStub        func() (uint32, error)
	acquireMutex       sync.RWMutex
	acquireArgsForCall []struct{}
	acquireReturns     struct {
		result1 uint32
		result2 error
	}
	ReleaseStub        func(uint32)
	releaseMutex       sync.RWMutex
	releaseArgsForCall []struct {
		arg1 uint32
	}
	RemoveStub        func(uint32) error
	removeMutex       sync.RWMutex
	removeArgsForCall []struct {
		arg1 uint32
	}
	removeReturns struct {
		result1 error
	}
}

func (fake *FakePortPool) Acquire() (uint32, error) {
	fake.acquireMutex.Lock()
	fake.acquireArgsForCall = append(fake.acquireArgsForCall, struct{}{})
	fake.acquireMutex.Unlock()
	if fake.AcquireStub != nil {
		return fake.AcquireStub()
	} else {
		return fake.acquireReturns.result1, fake.acquireReturns.result2
	}
}

func (fake *FakePortPool) AcquireCallCount() int {
	fake.acquireMutex.RLock()
	defer fake.acquireMutex.RUnlock()
	return len(fake.acquireArgsForCall)
}

func (fake *FakePortPool) AcquireReturns(result1 uint32, result2 error) {
	fake.AcquireStub = nil
	fake.acquireReturns = struct {
		result1 uint32
		result2 error
	}{result1, result2}
}

func (fake *FakePortPool) Release(arg1 uint32) {
	fake.releaseMutex.Lock()
	fake.releaseArgsForCall = append(fake.releaseArgsForCall, struct {
		arg1 uint32
	}{arg1})
	fake.releaseMutex.Unlock()
	if fake.ReleaseStub != nil {
		fake.ReleaseStub(arg1)
	}
}

func (fake *FakePortPool) ReleaseCallCount() int {
	fake.releaseMutex.RLock()
	defer fake.releaseMutex.RUnlock()
	return len(fake.releaseArgsForCall)
}

func (fake *FakePortPool) ReleaseArgsForCall(i int) uint32 {
	fake.releaseMutex.RLock()
	defer fake.releaseMutex.RUnlock()
	return fake.releaseArgsForCall[i].arg1
}

func (fake *FakePortPool) Remove(arg1 uint32) error {
	fake.removeMutex.Lock()
	fake.removeArgsForCall = append(fake.removeArgsForCall, struct {
		arg1 uint32
	}{arg1})
	fake.removeMutex.Unlock()
	if fake.RemoveStub != nil {
		return fake.RemoveStub(arg1)
	} else {
		return fake.removeReturns.result1
	}
}

func (fake *FakePortPool) RemoveCallCount() int {
	fake.removeMutex.RLock()
	defer fake.removeMutex.RUnlock()
	return len(fake.removeArgsForCall)
}

func (fake *FakePortPool) RemoveArgsForCall(i int) uint32 {
	fake.removeMutex.RLock()
	defer fake.removeMutex.RUnlock()
	return fake.removeArgsForCall[i].arg1
}

func (fake *FakePortPool) RemoveReturns(result1 error) {
	fake.RemoveStub = nil
	fake.removeReturns = struct {
		result1 error
	}{result1}
}

var _ kawasaki.PortPool = new(FakePortPool)
