// This file was generated by counterfeiter
package fakes

import (
	"sync"

	"github.com/cloudfoundry-incubator/guardian/rundmc"
)

type FakeStateStore struct {
	StoreStub        func(handle string, stopped bool)
	storeMutex       sync.RWMutex
	storeArgsForCall []struct {
		handle  string
		stopped bool
	}
	IsStoppedStub        func(handle string) bool
	isStoppedMutex       sync.RWMutex
	isStoppedArgsForCall []struct {
		handle string
	}
	isStoppedReturns struct {
		result1 bool
	}
}

func (fake *FakeStateStore) Store(handle string, stopped bool) {
	fake.storeMutex.Lock()
	fake.storeArgsForCall = append(fake.storeArgsForCall, struct {
		handle  string
		stopped bool
	}{handle, stopped})
	fake.storeMutex.Unlock()
	if fake.StoreStub != nil {
		fake.StoreStub(handle, stopped)
	}
}

func (fake *FakeStateStore) StoreCallCount() int {
	fake.storeMutex.RLock()
	defer fake.storeMutex.RUnlock()
	return len(fake.storeArgsForCall)
}

func (fake *FakeStateStore) StoreArgsForCall(i int) (string, bool) {
	fake.storeMutex.RLock()
	defer fake.storeMutex.RUnlock()
	return fake.storeArgsForCall[i].handle, fake.storeArgsForCall[i].stopped
}

func (fake *FakeStateStore) IsStopped(handle string) bool {
	fake.isStoppedMutex.Lock()
	fake.isStoppedArgsForCall = append(fake.isStoppedArgsForCall, struct {
		handle string
	}{handle})
	fake.isStoppedMutex.Unlock()
	if fake.IsStoppedStub != nil {
		return fake.IsStoppedStub(handle)
	} else {
		return fake.isStoppedReturns.result1
	}
}

func (fake *FakeStateStore) IsStoppedCallCount() int {
	fake.isStoppedMutex.RLock()
	defer fake.isStoppedMutex.RUnlock()
	return len(fake.isStoppedArgsForCall)
}

func (fake *FakeStateStore) IsStoppedArgsForCall(i int) string {
	fake.isStoppedMutex.RLock()
	defer fake.isStoppedMutex.RUnlock()
	return fake.isStoppedArgsForCall[i].handle
}

func (fake *FakeStateStore) IsStoppedReturns(result1 bool) {
	fake.IsStoppedStub = nil
	fake.isStoppedReturns = struct {
		result1 bool
	}{result1}
}

var _ rundmc.StateStore = new(FakeStateStore)
